/* $Id: 28800.h,v 1.2 1998/11/02 04:38:32 brian Exp $
******************************************************************************

   ATI 28800 Series -- register definitions and macros

   Copyright (C) 1998		Brian S. Julin	[bri@forcade.calyx.com]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _ATI_28800_h
#define _ATI_28800_h

#include <ATI/18800.h>

#define ATI_MEM_CTL	0x20
	#define ATI20_16BIT_ROM_ENB	0x10

#define ATI_DIG_MON_DET	0x21
	#define ATI21_DIG_MON_DET_MASK	0x18
	#define ATI21_RESERVED_MASK	0xe7

#define ATI_VGA_OFLOW0	0x23
	#define ATI23_16BIT_ROM_ACC	0x07
	#define ATI23_CURSOR_START_B17	0x08
	#define ATI23_DISP_START_B17	0x10
	#define ATI23_RESERVED_MASK	0xe0

#define ATI_ROM_CTL0	0x24
	#define ATI24_ROM_PAGE0	0x0f
	#define ATI24_ROM_PAGE1	0xf0

#define ATI_ROM_CTL1	0x25
	#define ATI25_ROM_PAGE2		0x0f
	#define ATI25_ROM_PAGE3		0xf0

#define ATI_MISC0	0x26
	#define ATI26_FORCE_GENMO_ZERO	0x80

#define ATI_DAC_CTL0	0x27
	#define ATI27_TRUECOLR_ENB	0x01
	#define ATI27_TRUECOLR_DAC	0x0A
	#define ATI27_RESERVED		0x04
	#define ATI27_FORCE_PIXHI	0x30
	#define ATI27_DISP_ENB_SKEW	0x40
	#define ATI27_DIV3_CLK		0x80

/* Note use of following two registers is not the same for all chipsets */
#define ATI_VLCOUNT0	0x28
	#define ATI28_VLCOUNT_MASK	0x03
#define ATI_VLCOUNT1	0x29

#define ATI_SYSINFO	0x2A
	#define ATI2A_CHIPREV		0x0f
	#define ATI2A_BUS_CFG		0x10
	#define ATI2A_RESERVED_MASK	0xe0

#define ATI_MEMCLK_CTL2	0x2B
	#define ATI2B_VID_ZERO_WAIT	0x01
	#define ATI2B_BIOS_ZERO_WAIT	0x02
	#define ATI2B_2ND_DISP_SEL	0x08
	#define ATI2B_DAC_WRITE_LOCK	0x10
	#define ATI2B_ZERO_WAIT_ENB	0x20
	#define ATI2B_RESTRICT_ACCESS	0x40
	#define ATI2B_TEXT_DELAY	0x80

#define ATI_MISC_CTL	0x2C
	#define ATI2C_ENB_LINEAR_FB	0x01
	#define ATI2C_16BIT_PLANAR	0x40
	#define ATI2C_RESERVED_MASK	0xbe

#define ATI_VGA_OFLOW1	0x2D
	#define ATI2D_HTOTAL_B8		0x01
	#define ATI2D_BLANKSTART_B8	0x02
	#define ATI2D_HSYNC_START_B8	0x04
	#define ATI2D_OFLOW_ENB		0x08
	#define ATI2D_CHARMAP_ADDR	0xf0
	
/* Additional/different values for Register ATI30 */
	#define ATI30_TEXT_MEM_ORG	0x02
	#define ATI30_CURSOR_START_B16	0x04
	#define ATI30_MEMORY_SIZE_MASK	0x18
	#define ATI30_256K_RAM		0x00
	#define ATI30_512K_RAM		0x10
	#define ATI30_1M_RAM		0x08
	#define ATI30_ALT_8BIT_COLOR	0x20
	#define ATI30_FAST_VRAM		0x80

/* Additional values for Register ATI36 */
	#define ATI36_CRTC_HICOUNT_ENB	0x01

/* Additional values for Register ATI3D */
	#define ATI3D_MEM_A0000_128K	0x01

#define ATI_MEMCLK_CTL3	0x3F
	#define ATI3F_ROM_PAGE		0x40
	#define ATI3F_ALT_MEM_LAYOUT	0x80

#endif /* Not defined _ATI_28800_h */
